<?php

/**
 * Historical data about non UTF-8 encodings that might be used in Dokeos LMS.
 * The following list may have some inconsistencies.
 * Put the probably most used for your language encoding at the first place.
 * For licensing terms, see dokeos_license.txt.
 */
return array(
	'arabic' => array('WINDOWS-1256', 'ISO-8859-6'),
	'asturian' => array('ISO-8859-15', 'WINDOWS-1252', 'ISO-8859-1'),
	'bosnian' => array('WINDOWS-1250'),
	'brazilian' => array('ISO-8859-15', 'WINDOWS-1252', 'ISO-8859-1'),
	'bulgarian' => array('WINDOWS-1251'),
	'catalan' => array('ISO-8859-15', 'WINDOWS-1252', 'ISO-8859-1'),
	'croatian' => array('WINDOWS-1250'),
	'czech' => array('WINDOWS-1250', 'ISO-8859-2'),
	'danish' => array('ISO-8859-15', 'WINDOWS-1252', 'ISO-8859-1'),
	'dari' => array('WINDOWS-1256'),
	'dutch' => array('ISO-8859-15', 'WINDOWS-1252', 'ISO-8859-1'),
	'english' => array('ISO-8859-15', 'WINDOWS-1252', 'ISO-8859-1'),
	'euskera' => array(' ISO-8859-15', 'WINDOWS-1252', 'ISO-8859-1'),
	'esperanto' => array('ISO-8859-15', 'WINDOWS-1252', 'ISO-8859-1'),
	'finnish' => array('ISO-8859-15', 'WINDOWS-1252', 'ISO-8859-1'),
	'french' => array('ISO-8859-15', 'WINDOWS-1252', 'ISO-8859-1'),
	'friulian' => array('ISO-8859-15', 'WINDOWS-1252', 'ISO-8859-1'),
	'galician' => array('ISO-8859-15', 'WINDOWS-1252', 'ISO-8859-1'),
	'georgian' => array('GEORGIAN-ACADEMY', 'GEORGIAN-PS'),
	'german' => array('ISO-8859-15', 'WINDOWS-1252', 'ISO-8859-1'),
	'greek' => array('WINDOWS-1253', 'ISO-8859-7'),
	'hebrew' => array('ISO-8859-8', 'WINDOWS-1255'),
	'hungarian' => array('WINDOWS-1250', 'ISO-8859-2'),
	'indonesian' => array('ISO-8859-15', 'WINDOWS-1252', 'ISO-8859-1'),
	'italian' => array('ISO-8859-15', 'WINDOWS-1252', 'ISO-8859-1'),
	'japanese' => array('EUC-JP', 'ISO-2022-JP', 'Shift-JIS'),
	'korean' => array('EUC-KR', 'ISO-2022-KR', 'CP949'),
	'latvian' => array('WINDOWS-1257', 'ISO-8859-13'),
	'lithuanian' => array('WINDOWS-1257', 'ISO-8859-13'),
	'macedonian' => array('WINDOWS-1251'),
	'malay' => array('ISO-8859-15', 'WINDOWS-1252', 'ISO-8859-1'),
	'norwegian' => array('ISO-8859-15', 'WINDOWS-1252', 'ISO-8859-1'),
	'occitan' => array('ISO-8859-15', 'WINDOWS-1252', 'ISO-8859-1'),
	'pashto' => array('WINDOWS-1256'),
	'persian' => array('WINDOWS-1256'),
	'polish' => array('WINDOWS-1250', 'ISO-8859-2'),
	'portuguese' => array('ISO-8859-15', 'WINDOWS-1252', 'ISO-8859-1'),
	'quechua_cusco' => array('ISO-8859-15', 'WINDOWS-1252', 'ISO-8859-1'),
	'romanian' => array('WINDOWS-1250', 'ISO-8859-2'),
	'russian' => array('KOI8-R', 'WINDOWS-1251'),
	'serbian' => array('ISO-8859-15', 'WINDOWS-1252', 'ISO-8859-1', 'WINDOWS-1251'),
	'simpl_chinese' => array('GB2312', 'WINDOWS-936'),
	'slovak' => array('WINDOWS-1250', 'ISO-8859-2'),
	'slovenian' => array('WINDOWS-1250', 'ISO-8859-2'),
	'spanish' => array('ISO-8859-15', 'WINDOWS-1252', 'ISO-8859-1'),
	'swahili' => array('ISO-8859-1'),
	'swedish' => array('ISO-8859-15', 'WINDOWS-1252', 'ISO-8859-1'),
	'thai' => array('WINDOWS-874', 'ISO-8859-11'),
	'trad_chinese' => array('BIG-5', 'EUC-TW'),
	'turkce' => array('WINDOWS-1254', 'ISO-8859-9'),
	'ukrainian' => array('KOI8-U'),
	'vietnamese' => array('WINDOWS-1258', 'VISCII', 'TCVN'),
	'yoruba' => array('ISO-8859-15', 'WINDOWS-1252', 'ISO-8859-1')
);
